DAT	BIT	P0.0
	CLK	BIT	P0.1
	CS	BIT	P0.2
		ORG	0000H
		LJMP	START
		ORG	000BH
		LJMP	T0_INT
		ORG	0030H
START:	    MOV 	SP,#60H
		MOV		TMOD,#20H
		MOV		Tl1,#0E8H
		MOV		TH1,#0FEH
		MOV     PCON,#0
		MOV		Tl0,#33H
		MOV		TH0,#0FEH
		SETB		TR0
		SETB		TR1
		SETB		ET0
		SETB		EA
		CLR		P0.6
		MOV            SCON,#40H
		SETB		P0.7
		MOV		R0,#20H
		MOV		R1,#21H
		MOV		DPTR,#LEDGY
		SETB		DAT
loop:	        LCALL	TLC549_ADC
		MOV		27H,A
		MOV		SBUF,A 
		JNB		TI,$
		CLR		TI
		MOV		R3,#3
		MOV		R0,#20H
sloop: 	        MOV		B,#10 
		DIV		AB
		MOV		@R0,B
		INC		R0
		INC		R0
		DJNZ	R3,sloop
		MOV		A,20H
		MOVC	A,@A+DPTR
		MOV		21H,A
		MOV		A,22H
		MOVC	A,@A+DPTR
		MOV		23H,A
		MOV		A,24H
		MOVC	A,@A+DPTR
		MOV		25H,A
		MOV		P2,#0FFH
		MOV		P1,25H
		MOV		P2,#0DFH
		LCALL	DELAY
		MOV		P2,#0FFH
		MOV		P1,23H
		MOV		P2,#0BFH
		LCALL	DELAY
		MOV		P2,#0FFH
		MOV		P1,21H
		MOV		P2,#07FH
		LCALL	DELAY
		SJMP	loop
TLC549_ADC:
		PUSH	07H
		CLR	A
		SETB	CS
		CLR		CLK
		MOV	R7,#08H
		CLR	CS
		NOP
LOOP1:
		SETB	CLK
		MOV	C,DAT
		RLC	A
		CLR		CLK
		DJNZ	R7,LOOP1
		SETB	CS
		CLR		CLK
		SETB	DAT
		POP	07H
		RET
DELAY:
		PUSH	01H
		MOV	R1,#00H
		DJNZ	R1,$
		POP	01H
RET
LEDGY:	DB	0C0H,0F9H,0A4H,0B0H,99H,92H,82H,0F8H
		DB	80H,90H,88H,83H,0C6H,0A1H,86H,8EH
T0_INT:	        PUSH	PSW
		PUSH		ACC
		MOV		TL0,#33H
		MOV		TH0,#0FEH
		CLR		P0.6
		MOV		A,27H
		MOV		PSW,#00H
		SUBB		A , #120
		JC		EXIT
		SETB		P0.6
		CPL	P0.7
EXIT:	        POP	ACC
		POP	PSW
		RETI
end
